%define name		fplll
%define major		0
%define libfplll	%mklibname %{name} %{major}
%define libfplll_devel	%mklibname %{name} -d

Epoch:		1
Name:		%{name}
Group:		Sciences/Mathematics
License:	LGPLv2+
Summary:	LLL-reduction of euclidean lattices
Version:	4.0.1
Release:	2
Source:		http://perso.ens-lyon.fr/damien.stehle/fplll/lib%{name}-%{version}.tar.gz
URL:		http://perso.ens-lyon.fr/damien.stehle/fplll/
BuildRequires:	gmp-devel
BuildRequires:	mpfr-devel

Patch0:		%{name}-fplllv31.patch

%description
%{name}-%{version} contains several algorithms on lattices that rely on
floating-point computations. This includes implementations of the
floating-point LLL reduction algorithm, offering different
speed/guarantees ratios. It contains a 'wrapper' choosing the
estimated best sequence of variants in order to provide a guaranteed
output as fast as possible. In the case of the wrapper, the
succession of variants is oblivious to the user. It also includes
a rigorous floating-point implementation of the Kannan-Fincke-Pohst
algorithm that finds a shortest non-zero lattice vector, and the BKZ
reduction algorithm.

%package	-n %{libfplll}
Summary:	lib%{name} shared libraries
Group:		System/Libraries

%description	-n %{libfplll}
libfpll shared libraries. fplll is code that LLL-reduces euclidean lattices.

%package	-n %{libfplll_devel}
Summary:	lib%{name} libraries, includes, etc
Group:		Development/C
Requires:	%{libfplll} = %{EVRD}
Provides:	%{name}-devel = %{EVRD}
Conflicts:	%{_lib}fplll3 < 3.0-7
Obsoletes:	%{_lib}fplll3 < 3.0-7

%description	-n %{libfplll_devel}
libfpll libraries, includes, etc. fplll is code that LLL-reduces
euclidean lattices.

%prep
%setup -q -n lib%{name}-%{version}
%patch0 -p1

%build
%configure2_5x --disable-static LDFLAGS="-Wl,--as-needed $RPM_LD_FLAGS"

# Eliminate hardcoded rpaths, and workaround libtool moving all -Wl options
# after the libraries to be linked
sed -e 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' \
    -e 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' \
    -e 's|-nostdlib|-Wl,--as-needed &|' \
    -i libtool
%make

%install
%makeinstall_std
rm %{buildroot}%{_libdir}/libfplll.la

%check
export LD_LIBRARY_PATH=$PWD/src/.libs
make check

%files
%{_bindir}/*

%files		-n %{libfplll}
%{_libdir}/libfplll.so.*

%files		-n %{libfplll_devel}
%{_includedir}/%{name}.h
%{_includedir}/%{name}
%{_libdir}/libfplll.so


%changelog
* Tue Nov 06 2012 Paulo Andrade <pcpa@mandriva.com.br> 1:4.0.1-2
+ Revision: 821981
- Rebuild.
- Update to latest upstream release.

* Wed Dec 07 2011 Paulo Andrade <pcpa@mandriva.com.br> 3.0-6
+ Revision: 738706
- Rebuild for .la file removal.

* Sat Mar 05 2011 Paulo Andrade <pcpa@mandriva.com.br> 3.0-5
+ Revision: 642057
- Do not provide fplll in both, binaries and library packages

* Sun Dec 05 2010 Oden Eriksson <oeriksson@mandriva.com> 3.0-4mdv2011.0
+ Revision: 610744
- rebuild

* Mon Mar 08 2010 Paulo Andrade <pcpa@mandriva.com.br> 3.0-3mdv2010.1
+ Revision: 516796
- Update to latest upstream release
- Remove static devel package

* Sat May 09 2009 Paulo Andrade <pcpa@mandriva.com.br> 3.0-2mdv2010.0
+ Revision: 373563
+ rebuild (emptylog)

* Thu Mar 26 2009 Paulo Andrade <pcpa@mandriva.com.br> 3.0-1mdv2009.1
+ Revision: 361462
- Initial import of (lib)fplll version 3.0, "patchlevel 11".
  LLL-reduction of euclidean lattices
  http://perso.ens-lyon.fr/damien.stehle/english.html
- fplll

